using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Diagnostics;

namespace d3dmaze
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
        }
       
        
        #region "D3D Setup Code"
          #region Declare Objects
          int btn1 = 0;
          int btn2 = 0;
          int btn3 = 0;
          int btn4 = 0;
          int d1 = 0;
          int d2 = 0;
          float x1 = 4.5f;
          float z1 = 1.5f;
          int gameover = 0;
          float x2 = 0;
          float z2 = 10;
          float dx = 0;
          float dz = 0;
          int x3 = 0;
          int z3 = 0;
          float x4 = 0;
          float z4 = 0;
          //double dx2 = 0;
          //double dz2 = 0;
          float angle = 3.142159f / 2f;

          
          int[ , ] wx = new int [ 11 , 11] //horizontal walls arranged by roll (rank)
          {
            { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0 },
            { 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0 },
            { 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0 },
            { 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0 },
            { 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0 },
            { 0, 1, 0, 1, 0, 1, 1, 0, 0, 0, 0 },
            { 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0 },
            { 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0 },
            { 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0 },
            { 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0 },
            { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0 }
          };

          int[,] wz = new int[11, 11]
          {
            { 1, 0, 1, 0, 1, 1, 0, 0, 0, 1, 1 },
            { 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
            { 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 1 },
            { 1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1 },
            { 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1 },
            { 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1 },
            { 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1 },
            { 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1 },
            { 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1 },
            { 1, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1 },
            { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
          };

          public Device device;
          public Texture texture = null;
          public Texture texture2 = null;
          public VertexBuffer vertexbuffer1 = null;
          public CustomVertex.PositionNormalTextured[] vertice2 = new CustomVertex.PositionNormalTextured[20];

          #endregion

          #region BitMap Section


          static Bitmap bm1 = new Bitmap(255, 255);
          Graphics b1 = Graphics.FromImage(bm1);
          static Bitmap bm2 = new Bitmap(255, 255);
          Graphics b2 = Graphics.FromImage(bm2);

          static Bitmap bmt1 = new Bitmap(150, 500);
          Graphics btext = Graphics.FromImage(bmt1);
        
          Image sp1 = (Image)(new Bitmap(d3dmaze.Properties.Resources.tile1));
          Image sp2 = (Image)(new Bitmap(d3dmaze.Properties.Resources.tile1));
        
          #endregion

        public bool InitializeGraphics()
        {
            
            b1.FillRectangle(Brushes.Black, 2.0F, 2.0F, 250.0F, 250.0F);
            b1.DrawImage(sp1, 5, 5);
            b2.DrawImage(sp1, 0, 0);
            #region present parameters section   used to make device


            PresentParameters d3dpp = new PresentParameters();
            d3dpp.Windowed = true;
            d3dpp.SwapEffect = SwapEffect.Discard;
            //d3dpp.SwapEffect = SwapEffect.Flip;
           
            d3dpp.AutoDepthStencilFormat = DepthFormat.D16;
            d3dpp.EnableAutoDepthStencil = true;

            #endregion   
            #region Make new device

            

            // Best: Hardware device and hardware vertex processing.
            try
            {
                device = new Device(0, DeviceType.Hardware, pic3d,
                    CreateFlags.HardwareVertexProcessing, d3dpp);
                Debug.WriteLine("Hardware, HardwareVertexProcessing");
            }
            catch { }

            // Good: Hardware device and software vertex processing.
            if (device == null)
            {
                try
                {
                    device = new Device(0, DeviceType.Hardware, pic3d,
                        CreateFlags.SoftwareVertexProcessing, d3dpp);
                    Debug.WriteLine("Hardware, SoftwareVertexProcessing");
                }
                catch { }
            }

            // Adequate?: Software device and software vertex processing.
            if (device == null)
            {
                try
                {
                    device = new Device(0, DeviceType.Reference, pic3d,
                        CreateFlags.SoftwareVertexProcessing, d3dpp);
                    Debug.WriteLine("Reference, SoftwareVertexProcessing");
                }
                catch (Exception ex)
                {
                    // If we still can't make a device, give up.
                    MessageBox.Show("Error initializing Direct3D\n\n" + ex.Message,
                        "Direct3D Error", MessageBoxButtons.OK);
                    return false;
                }
            }
            #endregion

            #region device.methods

            
            device.RenderState.Lighting = true;
            //device.RenderState.Lighting = false;

            device.RenderState.CullMode = Cull.None;
            device.RenderState.ZBufferEnable = true;
            device.VertexFormat = CustomVertex.PositionNormalTextured.Format;
            device.TextureState[0].ColorOperation = TextureOperation.Modulate;
            device.TextureState[0].ColorArgument1 = TextureArgument.TextureColor;
            device.TextureState[0].ColorArgument2 = TextureArgument.Diffuse;
            device.TextureState[0].AlphaOperation = TextureOperation.Disable;
            device.SetStreamSource(0, vertexbuffer1, 0);

            #endregion
            SetupLights();
            
            #region create vertex buffer     vertexbuffer1

            vertexbuffer1 = new VertexBuffer(
                                                typeof(CustomVertex.PositionNormalTextured),
                                                3000,
                                                device,
                                                0,
                                                CustomVertex.PositionNormalTextured.Format,
                                                Pool.Managed);
            device.SetStreamSource(0, vertexbuffer1, 0);
            #endregion
            texture = Texture.FromBitmap(device, (Bitmap)bm1, Usage.None, Pool.Managed);
            texture2 = Texture.FromBitmap(device, (Bitmap)bm2, Usage.None, Pool.Managed);
            device.SetTexture(0, texture);
            vertice2 = (CustomVertex.PositionNormalTextured[]) vertexbuffer1.Lock(0, 0);
            #region Make Walls 
            // 0-49
            // a,x,z y=0 a= next block of six    x,y,z are start points
            MakeWallX(0 * 6, 0, 0); MakeWallX(1 * 6, 1, 0); MakeWallX(2 * 6, 2, 0);
            MakeWallX(3 * 6, 3, 0); MakeWallX(4 * 6, 4, 0);
            MakeWallX(5 * 6, 5, 0); MakeWallX(6 * 6, 6, 0); MakeWallX(7 * 6, 7, 0);
            MakeWallX(8 * 6, 8, 0); MakeWallX(9 * 6, 9, 0);

            MakeWallX(10 * 6, 6, 1); MakeWallX(11 * 6, 8, 1); MakeWallX(12 * 6, 3, 2);
            MakeWallX(13 * 6, 6, 2); MakeWallX(14 * 6, 7, 2);
            MakeWallX(15 * 6, 8, 2); MakeWallX(16 * 6, 3, 3); MakeWallX(17 * 6, 5, 3);
            MakeWallX(18 * 6, 7, 3); MakeWallX(19 * 6, 2, 4);

            MakeWallX(20 * 6, 3, 4); MakeWallX(21 * 6, 5, 4); MakeWallX(22 * 6, 1, 5);
            MakeWallX(23 * 6, 3, 5); MakeWallX(24 * 6, 5, 5);
            MakeWallX(25 * 6, 6, 5); MakeWallX(26 * 6, 4, 6); MakeWallX(27 * 6, 5, 6);
            MakeWallX(28 * 6, 6, 6); MakeWallX(29 * 6, 1, 7);

            MakeWallX(30 * 6, 2, 7); MakeWallX(31 * 6, 5, 7); MakeWallX(32 * 6, 7, 7);
            MakeWallX(33 * 6, 2, 8); MakeWallX(34 * 6, 3, 8);
            MakeWallX(35 * 6, 6, 8); MakeWallX(36 * 6, 7, 8); MakeWallX(37 * 6, 1, 9);
            MakeWallX(38 * 6, 2, 9); MakeWallX(39 * 6, 5, 9);

            MakeWallX(40 * 6, 6, 9); MakeWallX(41 * 6, 8, 9); MakeWallX(42 * 6, 0, 10);
            MakeWallX(43 * 6, 1, 10); MakeWallX(44 * 6, 2, 10);
            MakeWallX(45 * 6, 3, 10); MakeWallX(46 * 6, 4, 10); MakeWallX(47 * 6, 5, 10);
            MakeWallX(48 * 6, 6, 10); MakeWallX(49 * 6, 7, 10); MakeWallX(50 * 6, 9, 10);


            MakeWallZ(51 * 6, 0, 0); MakeWallZ(52 * 6, 0, 1); MakeWallZ(53 * 6, 2, 0);
            MakeWallZ(54 * 6, 0, 2); MakeWallZ(55 * 6, 4, 0);
            MakeWallZ(56 * 6, 5, 0); MakeWallZ(57 * 6, 0, 3); MakeWallZ(58 * 6, 0, 4);
            MakeWallZ(59 * 6, 0, 5); MakeWallZ(60 * 6, 9, 0);

            MakeWallZ(61 * 6, 1, 1); MakeWallZ(62 * 6, 1, 2); MakeWallZ(63 * 6, 1, 3);
            MakeWallZ(64 * 6, 1, 4); MakeWallZ(65 * 6, 1, 5);
            MakeWallZ(66 * 6, 1, 6); MakeWallZ(67 * 6, 1, 8); MakeWallZ(68 * 6, 2, 0);
            MakeWallZ(69 * 6, 2, 1); MakeWallZ(70 * 6, 2, 2);

            MakeWallZ(71 * 6, 2, 3); MakeWallZ(72 * 6, 2, 5); MakeWallZ(73 * 6, 3, 1);
            MakeWallZ(74 * 6, 3, 5); MakeWallZ(75 * 6, 3, 6);
            MakeWallZ(76 * 6, 4, 0); MakeWallZ(77 * 6, 4, 1); MakeWallZ(78 * 6, 4, 3);
            MakeWallZ(79 * 6, 4, 4); MakeWallZ(80 * 6, 4, 6);

            MakeWallZ(81 * 6, 4, 7); MakeWallZ(82 * 6, 4, 8); MakeWallZ(83 * 6, 5, 0);
            MakeWallZ(84 * 6, 5, 1); MakeWallZ(85 * 6, 5, 2);
            MakeWallZ(86 * 6, 5, 4); MakeWallZ(87 * 6, 5, 7); MakeWallZ(88 * 6, 5, 8);
            MakeWallZ(89 * 6, 6, 1); MakeWallZ(90 * 6, 7, 2);

            MakeWallZ(91 * 6, 7, 3); MakeWallZ(92 * 6, 7, 4); MakeWallZ(93 * 6, 7, 6);
            MakeWallZ(94 * 6, 8, 1); MakeWallZ(95 * 6, 8, 3);
            MakeWallZ(96 * 6, 8, 4); MakeWallZ(97 * 6, 8, 5); MakeWallZ(98 * 6, 8, 6);
            MakeWallZ(99 * 6, 8, 8); MakeWallZ(100 * 6, 8, 9); MakeWallZ(101 * 6, 9, 0);

            MakeWallZ(102 * 6, 9, 2); MakeWallZ(103 * 6, 9, 3); MakeWallZ(104 * 6, 9, 4);
            MakeWallZ(105 * 6, 9, 6); MakeWallZ(106 * 6, 9, 7);
            MakeWallZ(107 * 6, 9, 8); MakeWallZ(108 * 6, 10, 0); MakeWallZ(109 * 6, 10, 1);
            MakeWallZ(110 * 6, 10, 2); MakeWallZ(111 * 6, 10, 3); MakeWallZ(112 * 6, 10, 4);

            MakeWallZ(113 * 6, 10, 5); MakeWallZ(114 * 6, 10, 6); MakeWallZ(115 * 6, 10, 7);
            MakeWallZ(116 * 6, 10, 8); MakeWallZ(117 * 6, 10, 9);

            MakeWallZ(118 * 6, 0, 6); MakeWallZ(119 * 6, 0, 7); MakeWallZ(120 * 6, 0, 8);
            MakeWallZ(121 * 6, 0, 9); MakeWallZ(122 * 6, 3, 9);


            #endregion
            MakeFloor();
            vertexbuffer1.Unlock();
            
            return true;
        }


        public void MakeWallX(int a,int x,int z)
        {   // These walls run in the X direction. (East and West)
            int y = 0;
            vertice2[a].X = x;
            vertice2[a].Y = y;
            vertice2[a].Z = z;
            vertice2[a].Tu = 0;
            vertice2[a].Tv = 0;
            
            vertice2[a + 1].X = 0+x;
            vertice2[a + 1].Y = 1+y;
            vertice2[a + 1].Z = 0+z;
            vertice2[a + 1].Tu = 0;
            vertice2[a + 1].Tv = 1;

            vertice2[a + 2].X = 1+x;
            vertice2[a + 2].Y = 1+y;
            vertice2[a + 2].Z = 0+z;
            vertice2[a + 2].Tu = 1;
            vertice2[a + 2].Tv = 1;


            vertice2[a + 3].X = 0+x;
            vertice2[a + 3].Y = 0+y;
            vertice2[a + 3].Z = 0+z;
            vertice2[a + 3].Tu = 0;
            vertice2[a + 3].Tv = 0;

            vertice2[a + 4].X = 1+x;
            vertice2[a + 4].Y = 1+y;
            vertice2[a + 4].Z = 0+z;
            vertice2[a + 4].Tu = 1;
            vertice2[a + 4].Tv = 1;

            vertice2[a + 5].X = 1+x;
            vertice2[a + 5].Y = 0+y;
            vertice2[a + 5].Z = 0+z;
            vertice2[a + 5].Tu = 1;
            vertice2[a + 5].Tv = 0;
           
        }
        public void MakeWallZ(int a, int x, int z)
        {   // These walls run in the Z direction. (North and South)
            int y = 0;
            vertice2[a].X = x;
            vertice2[a].Y = y;
            vertice2[a].Z = z;
            vertice2[a].Tu = 0;
            vertice2[a].Tv = 0;

            vertice2[a + 1].X = 0 + x;
            vertice2[a + 1].Y = 1 + y;
            vertice2[a + 1].Z = 0 + z;
            vertice2[a + 1].Tu = 0;
            vertice2[a + 1].Tv = 1;

            vertice2[a + 2].X = 0 + x;
            vertice2[a + 2].Y = 1 + y;
            vertice2[a + 2].Z = 1 + z;
            vertice2[a + 2].Tu = 1;
            vertice2[a + 2].Tv = 1;


            vertice2[a + 3].X = 0 + x;
            vertice2[a + 3].Y = 0 + y;
            vertice2[a + 3].Z = 0 + z;
            vertice2[a + 3].Tu = 0;
            vertice2[a + 3].Tv = 0;

            vertice2[a + 4].X = 0 + x;
            vertice2[a + 4].Y = 1 + y;
            vertice2[a + 4].Z = 1 + z;
            vertice2[a + 4].Tu = 1;
            vertice2[a + 4].Tv = 1;

            vertice2[a + 5].X = 0 + x;
            vertice2[a + 5].Y = 0 + y;
            vertice2[a + 5].Z = 1 + z;
            vertice2[a + 5].Tu = 1;
            vertice2[a + 5].Tv = 0;

        }
        public void MakeFloorPanel(int a,int x, int z)
        {   
            int y = 0;
            vertice2[a].X = x;
            vertice2[a].Y = y;
            vertice2[a].Z = z;
            vertice2[a].Tu = 0;
            vertice2[a].Tv = 0;

            vertice2[a + 1].X = 0 + x;
            vertice2[a + 1].Y = y;
            vertice2[a + 1].Z = 1 + z;
            vertice2[a + 1].Tu = 0;
            vertice2[a + 1].Tv = 1;

            vertice2[a + 2].X = 1 + x;
            vertice2[a + 2].Y = y;
            vertice2[a + 2].Z = 1 + z;
            vertice2[a + 2].Tu = 1;
            vertice2[a + 2].Tv = 1;


            vertice2[a + 3].X = 0 + x;
            vertice2[a + 3].Y = y;
            vertice2[a + 3].Z = 0 + z;
            vertice2[a + 3].Tu = 0;
            vertice2[a + 3].Tv = 0;

            vertice2[a + 4].X = 1 + x;
            vertice2[a + 4].Y = y;
            vertice2[a + 4].Z = 1 + z;
            vertice2[a + 4].Tu = 1;
            vertice2[a + 4].Tv = 1;

            vertice2[a + 5].X = 1 + x;
            vertice2[a + 5].Y = 0 ;
            vertice2[a + 5].Z = 0 + z;
            vertice2[a + 5].Tu = 1;
            vertice2[a + 5].Tv = 0;

        }
        private void SetupLights()
        {
            System.Drawing.Color col = System.Drawing.Color.White;
            //Set up a material. The material here just has the diffuse and ambient
            //colors set to yellow. Note that only one material can be used at a time.
            Material mtrl = new Material();
            mtrl.Diffuse = col;
            mtrl.Ambient = col;
            device.Material = mtrl;

            //Set up a white, directional light, with an oscillating direction.
            //Note that many lights may be active at a time (but each one slows down
            //the rendering of our scene). However, here we are just using one. Also,
            //we need to set the D3DRS_LIGHTING renderstate to enable lighting

            device.Lights[0].Type = LightType.Directional;
            device.Lights[0].Diffuse = System.Drawing.Color.White;
            device.Lights[0].Direction = new Vector3((float)Math.Cos(Environment.TickCount / 250.0f), 1.0f, (float)Math.Sin(Environment.TickCount / 250.0f));

            device.Lights[0].Enabled = true;//turn it on

            //Finally, turn on some ambient light.
            //Ambient light is light that scatters and lights all objects evenly
            device.RenderState.Ambient = System.Drawing.Color.White;       //FromArgb(0x202020);
        }
        public void MakeFloor()
        {
            int x = 0;
            int z = 0;
            int a = 900;
            while (x < 11)
            {
                while (z < 11)
                {
                    MakeFloorPanel(a, x, z);
                    z = z + 1;
                    a = a + 6;
                }
                x = x + 1;
                z = 0;
            }

        }

      #endregion // D3D Setup Code

        #region "D3D Drawing Code"
        
          public void Render()
        {
            device.Clear(ClearFlags.Target | ClearFlags.ZBuffer, Color.MidnightBlue, 1, 0);
            device.BeginScene();
            if(gameover==0)UpDatePosition();
            
            device.DrawPrimitives(PrimitiveType.TriangleList, 0, 1000);
            
            device.EndScene();
            device.Present();
        }
          
        
          private void UpDatePosition()
          {
              
            int a = 0;   // x3,z3= present location as int
            int b = 0;   // x1,z1= present location as float
            int c = 0;   // x4,z4 difference of the first two
            int d = 0;
            if (x1 > 10) x1 = 10;
            if (z1 > 10) z1 = 10;
            if (btn3 == 1)  // Forward
            {
                x1 = x1 + .01f*(float)dx;      // dx = x-component of movement
                x2 = x2 + .01f*(float)dx;      // x2 = new look-at point
                z1 = z1 + .01f * (float)dz;    // dz = z-component of movement
                z2 = z2 + .01f * (float)dz;
                
                x4 = x1 - x3;  // x4 = 0-.99
                z4 = z1 - z3;
                if(dz>0 && z3<10) a = wx[z3+1, x3]; // forward z north  are you facing a wall?
                if(dz<0) b = wx[z3, x3];   // reverse z south
                if (dx > 0 && x3<10) c = wz[z3 , x3+1]; // forward x north  are you facing a wall?
                if (dx < 0) d = wz[z3, x3];   // reverse x south
                if (x3 == 8 && z3 == 9) a = 0;
                if ( x3 == 8 && z3 == 10) gameover = 1;
                d1 = a;
                d2 = b;
                if ( a == 1 && dz>0 && z4>.8) z1 = z1 - .01f * (float)dz; // north
                if (b == 1 && dz < 0 && z4 < .2) z1 = z1 - .01f * (float)dz; // south
                if (c == 1 && dx > 0 && x4 > .8) x1 = x1 - .01f * (float)dx; // east
                if (d == 1 && dx < 0 && x4 < .2) x1 = x1 - .01f * (float)dx; // west
            }
            if (btn4 == 1)  // Reverse
            {
                x1 = x1 - .1f * (float)dx;
                x2 = x2 - .1f * (float)dx;
                x3 = (int)x1;           // x3= x1 without the remainder
                z3 = (int)z1;
                x4 = x1 - x3;  // x4 = 0-.99
                z4 = z1 - z3;
               if (z4>.1) z1 = z1 - .1f * (float)dz;
               if (z4 > .1) z2 = z2 - .1f * (float)dz;
               if (x4 > .1) x1 = x1 - .1f * (float)dx;
               if (x4 > .1) x2 = x2 - .1f * (float)dx;
            }
            if (btn1 == 1) angle = angle + .01F;
            if (btn2 == 1) angle = angle - .01F;
           
            dx = (float)Math.Cos(angle);
            dz = (float)Math.Sin(angle);
            x3 = (int)x1;           // x3= x1 without the remainder
            z3 = (int)z1;
            if (x3 < 0) x3 = 0;        // limits of maze
            if (z3 < 0) z3 = 0;
            if (x3 > 10) x3 = 10;
            if (z3 > 10) x3 = 10;
            
            x2 = x1+((float)dx * 10f); // update lookat point
            z2 = z1+((float)dz * 10f);

            device.Transform.View = Matrix.LookAtLH( // camara location and point of view
                new Vector3(x1, .5f, z1 ), // eye point
                new Vector3(x2, .5f, z2),  // point to look at
                new Vector3(0, 1, 0));     // up direction


            // Projection Matrix:
            // Perspective transformation defined by:
            //       Field of view           Pi / 4
            //       Aspect ratio            1
            //       Near clipping plane     Z = 1
            //       Far clipping plane      Z = 100
            device.Transform.Projection =
                Matrix.PerspectiveFovLH((float) 3.142 / 4f , 1, .1f, 100);
        }
          #endregion // D3D Drawing Code
        #region Events
        
        
        private void Form1_Load(object sender, EventArgs e)
        {
           // b1.FillRectangle(Brushes.Red, 2.0F, 2.0F, 250.0F, 250.0F);
           
        }

        private void button1_MouseDown(object sender, MouseEventArgs e)
        {
            btn1 = 1;
        }

        private void button2_MouseDown(object sender, MouseEventArgs e)
        {
            btn2 = 1;
        }

        private void button1_MouseUp(object sender, MouseEventArgs e)
        {
            btn1 = 0;
        }

        private void button2_MouseUp(object sender, MouseEventArgs e)
        {
            btn2 = 0;
        }

        private void button3_MouseDown(object sender, MouseEventArgs e) // Forward
        {
            
            btn3 = 1;
        }

        private void button3_MouseUp(object sender, MouseEventArgs e)
        {
            btn3 = 0;
        }
        
        private void button4_MouseDown(object sender, MouseEventArgs e) // Reverse
        {
            btn4 = 1;
        }

        private void button4_MouseUp(object sender, MouseEventArgs e)
        {
            btn4 = 0;
        }
        

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bmt1, 5,50);
        }
        #endregion
        private void timer1_Tick(object sender, EventArgs e)
        {
            
           
            btext.FillRectangle(Brushes.DarkGray, 0F, 0F, 130.0F, 450.0F);
            btext.DrawString(x4.ToString(),new Font("Arial", 10.0F), Brushes.Black, 5, 10);
            btext.DrawString(z4.ToString(), new Font("Arial", 10.0F), Brushes.Black, 5, 25);
            btext.DrawString(d1.ToString(), new Font("Arial", 10.0F), Brushes.Black, 5, 40);
            btext.DrawString(d2.ToString(), new Font("Arial", 10.0F), Brushes.Black, 5, 55);

            Invalidate();
            Update();
        }

    }
}